# PyHelpers

[![Python version](https://img.shields.io/pypi/pyversions/pyhelpers)](https://docs.python.org/3/) 
[![Documentation status](https://readthedocs.org/projects/pyhelpers/badge/?version=latest)](https://pyhelpers.readthedocs.io/en/latest/?badge=latest)
[![License](https://img.shields.io/pypi/l/pyhelpers)](https://github.com/mikeqfu/pyhelpers/blob/master/LICENSE)
[![Codacy grade (Code quality)](https://app.codacy.com/project/badge/Grade/c3ed8571c494450da12cb0c4d3c8c7e9)](https://www.codacy.com/gh/mikeqfu/pyhelpers/dashboard?utm_source=github.com&amp;utm_medium=referral&amp;utm_content=mikeqfu/pyhelpers&amp;utm_campaign=Badge_Grade)
[![Zenodo - DOI](https://zenodo.org/badge/173177909.svg)](https://zenodo.org/badge/latestdoi/173177909)

PyHelpers is a lightweight open-source Python package designed as a versatile toolkit for simplifying data (pre)processing tasks. It offers a comprehensive range of practical utilities to facilitate common data manipulation operations. These utilities encompass the ability to read and write file-like objects, efficiently handle various data types such as geographical and textual data, and establish streamlined communication with relational databases like PostgreSQL and Microsoft SQL Server.

## Installation

To install the latest release of pyhelpers from [PyPI](https://pypi.org/project/pyhelpers/) via [pip](https://pip.pypa.io/en/stable/cli/pip/):

```bash
pip install --upgrade pyhelpers
```

For more information, please refer to [Installation](https://pyhelpers.readthedocs.io/en/latest/installation.html).

## Documentation

The full PyHelpers documentation (including detailed examples and a quick-start tutorial) is hosted on [ReadTheDocs](https://readthedocs.org/projects/pyhelpers/): [[HTML](https://pyhelpers.readthedocs.io/en/latest/)\] \[[PDF](https://pyhelpers.readthedocs.io/_/downloads/en/latest/pdf/)].

## Cite as

Fu, Q. (2020). PyHelpers: an open-source toolkit for facilitating Python users' data manipulation tasks. Zenodo. [doi:10.5281/zenodo.4017438](https://doi.org/10.5281/zenodo.4017438)

```bibtex
@software{qian_fu_pyhelpers_4017438,
  author    = {Qian Fu},
  title     = {{PyHelpers: an open-source toolkit for facilitating
                Python users' data manipulation tasks}},
  year      = 2020,
  publisher = {Zenodo},
  doi       = {10.5281/zenodo.4017438},
  url       = {https://doi.org/10.5281/zenodo.4017438}
}
```

(Please also refer to the export options from [Zenodo](https://zenodo.org/search?page=1&size=20&q=conceptrecid:%224017438%22&sort=-version&all_versions=True) to reference the specific version of PyHelpers as appropriate.)

## Contributors

<!--suppress HtmlDeprecatedAttribute -->
<table>
  <tbody>
    <tr>
      <td align="center">
        <a href="https://github.com/mikeqfu" target="_blank"><img src="https://avatars.githubusercontent.com/u/1729711?v=4?s=100" width="100px;" alt="Qian Fu"/><br><sub><b>Qian Fu</b></sub></a><br>
        <a href="https://github.com/mikeqfu/pyhelpers" target="_blank" title="Seeding">🌱</a>
        <a href="https://github.com/mikeqfu/pyhelpers/commits?author=mikeqfu" target="_blank" title="Code">💻</a>
        <a href="https://github.com/mikeqfu/pyhelpers/tree/master/tests" target="_blank" title="Tests">🧪</a>
        <a href="https://pyhelpers.readthedocs.io/en/latest/" target="_blank" title="Documentation">📖</a>
      </td>
      <td align="center">
        <a href="https://github.com/xyluo25" target="_blank"><img src="https://avatars.githubusercontent.com/u/36498464?v=4?s=100" width="100px;" alt="Xiangyong Luo"/><br><sub><b>Xiangyong Luo</b></sub></a><br>
        <a href="https://github.com/mikeqfu/pyhelpers/commits?author=xyluo25" target="_blank" title="Code">💻</a>
      </td>
  </tbody>
</table>

## License

PyHelpers is licensed under [GNU General Public License v3](https://github.com/mikeqfu/pyhelpers/blob/master/LICENSE) or later (GPLv3+).
